Debian Bug report logs - #700177
dpkg-dev: please reject native/non-native version when building native/non-native source packages

version graph

Package: dpkg-dev; Maintainer for dpkg-dev is Dpkg Developers <debian-dpkg@lists.debian.org>; Source for dpkg-dev is src:dpkg.

Reported by: "Bernhard R. Link" <brlink@debian.org>

Date: Sat, 9 Feb 2013 14:33:05 UTC

Severity: wishlist

Tags: patch

Found in version dpkg/1.16.9

Fixed in version dpkg/1.17.0

Done: Guillem Jover <guillem@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#700177; Package dpkg-dev. (Sat, 09 Feb 2013 14:33:07 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Bernhard R. Link" <brlink@debian.org>:
New Bug report received and forwarded. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Sat, 09 Feb 2013 14:33:07 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: "Bernhard R. Link" <brlink@debian.org>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: dpkg-dev: please reject native/non-native version when building native/non-native source packages
Date: Sat, 9 Feb 2013 15:18:13 +0100
[Message part 1 (text/plain, inline)]
Package: dpkg-dev
Version: 1.16.9
Severity: wishlist
Tags: patch

Please ensure that the package version matches its nativity state
in 3.0 (quilt/native) packages. Having dpkg-source allow to create
native packages with non-native versions and non-native packages with
native versions can be quite confusing, so better reject them directly.
(Attached patch does this for 3.0 (quilt) and 3.0 (native) packages,
where this change should be safe to be done and does not touch any legacy
source package formats).

From: "Bernhard R. Link" <brlink@debian.org>
Date: Sat, 9 Feb 2013 14:59:00 +0100
Subject: [PATCH] Dpkg::Version,
 Dpkg::Source::Package::V3::{quilt,native}: catch
 invalid version strings

Ensure that a 3.0 (quilt) package has a non-native version and that a
3.0 (native) package has a native version.
To get the information, extend Dpkg::Version with a is_native method to
check whether a version has a revision or not.
---
 scripts/Dpkg/Source/Package/V3/native.pm |    4 +++-
 scripts/Dpkg/Source/Package/V3/quilt.pm  |    2 ++
 scripts/Dpkg/Version.pm                  |   11 +++++++++++
 3 files changed, 16 insertions(+), 1 deletion(-)

diff --git a/scripts/Dpkg/Source/Package/V3/native.pm b/scripts/Dpkg/Source/Package/V3/native.pm
index ba6539a..32e3c1b 100644
--- a/scripts/Dpkg/Source/Package/V3/native.pm
+++ b/scripts/Dpkg/Source/Package/V3/native.pm
@@ -64,7 +64,9 @@ sub do_extract {
 }
 
 sub can_build {
-    return 1;
+    my ($self, $dir) = @_;
+    my $v = Dpkg::Version->new($self->{'fields'}->{'Version'});
+    return (!!$v->is_native(), _g("native package version may not have a revision"));
 }
 
 sub do_build {
diff --git a/scripts/Dpkg/Source/Package/V3/quilt.pm b/scripts/Dpkg/Source/Package/V3/quilt.pm
index f5875c1..8a6cc54 100644
--- a/scripts/Dpkg/Source/Package/V3/quilt.pm
+++ b/scripts/Dpkg/Source/Package/V3/quilt.pm
@@ -72,6 +72,8 @@ sub can_build {
     my ($self, $dir) = @_;
     my ($code, $msg) = $self->SUPER::can_build($dir);
     return ($code, $msg) if $code eq 0;
+    my $v = Dpkg::Version->new($self->{'fields'}->{'Version'});
+    return (0, _g("version does not contain a revision")) if $v->is_native();
     my $quilt = $self->build_quilt_object($dir);
     $msg = $quilt->find_problems();
     return (0, $msg) if $msg;
diff --git a/scripts/Dpkg/Version.pm b/scripts/Dpkg/Version.pm
index 26ee154..042bd8e 100644
--- a/scripts/Dpkg/Version.pm
+++ b/scripts/Dpkg/Version.pm
@@ -145,6 +145,17 @@ sub revision {
     return $self->{'revision'};
 }
 
+=item $v->is_native()
+
+Returns true if the version is native, false if it has a revision.
+
+=cut
+
+sub is_native {
+    my $self = shift;
+    return $self->{'no_revision'};
+}
+
 =item $v1 <=> $v2, $v1 < $v2, $v1 <= $v2, $v1 > $v2, $v1 >= $v2
 
 Numerical comparison of various versions numbers. One of the two operands
-- 
1.7.10.4


-- System Information:
Debian Release: 7.0
Architecture: amd64 (x86_64)

Kernel: Linux 3.2.0-4-amd64 (SMP w/4 CPU cores)
Locale: LANG=C, LC_CTYPE=de_DE.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/dash

Versions of packages dpkg-dev depends on:
ii  base-files    7.1
ii  binutils      2.22-7.1
ii  bzip2         1.0.6-4
ii  libdpkg-perl  1.16.9
ii  make          3.81-8.2
ii  patch         2.6.1-3
ii  xz-utils      5.1.1alpha+20120614-2

Versions of packages dpkg-dev recommends:
ii  build-essential          11.6
ii  fakeroot                 1.18.4-2
ii  gcc [c-compiler]         4:4.7.2-1
ii  gcc-4.6 [c-compiler]     4.6.3-15
ii  gcc-4.7 [c-compiler]     4.7.2-5
ii  gnupg                    1.4.12-7
ii  gpgv                     1.4.12-7
ii  libalgorithm-merge-perl  0.08-2

Versions of packages dpkg-dev suggests:
ii  debian-keyring  2012.11.15

-- no debconf information
[0003-Dpkg-Version-Dpkg-Source-Package-V3-quilt-native-cat.patch (text/x-diff, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#700177; Package dpkg-dev. (Sat, 09 Feb 2013 17:15:08 GMT) Full text and rfc822 format available.

Acknowledgement sent to Raphael Hertzog <hertzog@debian.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Sat, 09 Feb 2013 17:15:08 GMT) Full text and rfc822 format available.

Message #10 received at 700177@bugs.debian.org (full text, mbox):

From: Raphael Hertzog <hertzog@debian.org>
To: "Bernhard R. Link" <brlink@debian.org>, 700177@bugs.debian.org
Subject: Re: Bug#700177: dpkg-dev: please reject native/non-native version when building native/non-native source packages
Date: Sat, 9 Feb 2013 18:13:59 +0100
Hi,

On Sat, 09 Feb 2013, Bernhard R. Link wrote:
> Please ensure that the package version matches its nativity state
> in 3.0 (quilt/native) packages. Having dpkg-source allow to create
> native packages with non-native versions and non-native packages with
> native versions can be quite confusing, so better reject them directly.

Right, but we have quite a few packages with such versions:
http://lintian.debian.org/tags/native-package-with-dash-version.html

And I'm pretty sure that some people are using native packages on purpose
for packages where they are not upstream.

I would not apply this change without a prior discussion on debian-devel
resulting in some consensus about this change.

Non-native packages with native versions are much less common so this
part of the change is certainly less problematic.

http://lintian.debian.org/tags/non-native-package-with-native-version.html

> (Attached patch does this for 3.0 (quilt) and 3.0 (native) packages,
> where this change should be safe to be done and does not touch any legacy
> source package formats).

Why do you consider it safer for 3.0 formats than for 1.0?

Cheers,
-- 
Raphaël Hertzog ◈ Debian Developer

Get the Debian Administrator's Handbook:
→ http://debian-handbook.info/get/



Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#700177; Package dpkg-dev. (Sat, 09 Feb 2013 19:51:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Guillem Jover <guillem@debian.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Sat, 09 Feb 2013 19:51:07 GMT) Full text and rfc822 format available.

Message #15 received at 700177@bugs.debian.org (full text, mbox):

From: Guillem Jover <guillem@debian.org>
To: "Bernhard R. Link" <brlink@debian.org>, 700177@bugs.debian.org
Subject: Re: Bug#700177: dpkg-dev: please reject native/non-native version when building native/non-native source packages
Date: Sat, 9 Feb 2013 20:49:10 +0100
Hi!

On Sat, 2013-02-09 at 15:18:13 +0100, Bernhard R. Link wrote:
> Package: dpkg-dev
> Version: 1.16.9
> Severity: wishlist
> Tags: patch
> 
> Please ensure that the package version matches its nativity state
> in 3.0 (quilt/native) packages. Having dpkg-source allow to create
> native packages with non-native versions and non-native packages with
> native versions can be quite confusing, so better reject them directly.
> (Attached patch does this for 3.0 (quilt) and 3.0 (native) packages,
> where this change should be safe to be done and does not touch any legacy
> source package formats).

Thanks, this makes sense, as what distinguishes format 1.0 and 3.0 is
that nativeness is also explicitly noted in the format version. I
would consider a mismatch between those two as a mistake. Also
checking the currently bogus packages in sid I think this change does
not affect many at all. None for non-native, and the following for native
ones:

  bespin
  chkconfig
  davical
  fenics
  getdata
  openoffice.org
  pimd
  python3-defaults
  tk-brief

So given this I'm preemtively merging this locally on my 1.17.x branch.
I guess we should file bug reports on those packages, and rise the
severity after such dpkg is upload to sid.

Thanks,
Guillem



Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#700177; Package dpkg-dev. (Sun, 10 Feb 2013 12:33:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Bernhard R. Link" <brlink@debian.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Sun, 10 Feb 2013 12:33:03 GMT) Full text and rfc822 format available.

Message #20 received at 700177@bugs.debian.org (full text, mbox):

From: "Bernhard R. Link" <brlink@debian.org>
To: 700177@bugs.debian.org
Subject: Re: Bug#700177: dpkg-dev: please reject native/non-native version when building native/non-native source packages
Date: Sun, 10 Feb 2013 13:29:44 +0100
* Raphael Hertzog <hertzog@debian.org> [130209 18:14]:
> On Sat, 09 Feb 2013, Bernhard R. Link wrote:
> > Please ensure that the package version matches its nativity state
> > in 3.0 (quilt/native) packages. Having dpkg-source allow to create
> > native packages with non-native versions and non-native packages with
> > native versions can be quite confusing, so better reject them directly.
>
> Right, but we have quite a few packages with such versions:
> http://lintian.debian.org/tags/native-package-with-dash-version.html

That list also lists 1.0 packages. I did not think it also had 3.0 ones
but Guillem found some...

> Non-native packages with native versions are much less common so this
> part of the change is certainly less problematic.
>
> http://lintian.debian.org/tags/non-native-package-with-native-version.html

The only one there is 1.0 if I parse that correctly.

> > (Attached patch does this for 3.0 (quilt) and 3.0 (native) packages,
> > where this change should be safe to be done and does not touch any legacy
> > source package formats).
>
> Why do you consider it safer for 3.0 formats than for 1.0?

Because 3.0 packages are in my experience much cleaner,
as most people not caring for package quality just stay with 1.0
and hate 3.0 with passion.
(And I do not care enough about the crufty old formats to suggest any
change with them).

        Bernhard R. Link



Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#700177; Package dpkg-dev. (Sun, 10 Feb 2013 12:45:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Bernhard R. Link" <brlink@debian.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Sun, 10 Feb 2013 12:45:03 GMT) Full text and rfc822 format available.

Message #25 received at 700177@bugs.debian.org (full text, mbox):

From: "Bernhard R. Link" <brlink@debian.org>
To: 700177@bugs.debian.org
Subject: Re: Bug#700177: dpkg-dev: please reject native/non-native version when building native/non-native source packages
Date: Sun, 10 Feb 2013 13:42:00 +0100
[Message part 1 (text/plain, inline)]
* Raphael Hertzog <hertzog@debian.org> [130209 18:14]:
> I would not apply this change without a prior discussion on debian-devel
> resulting in some consensus about this change.
> 
> Non-native packages with native versions are much less common so this
> part of the change is certainly less problematic.

To ease adoption, patch split into two attached.

        Bernhard R. Link
[0001-Dpkg-Version-Dpkg-Source-Package-V3-quilt-catch-nati.patch (text/x-diff, attachment)]
[0002-Dpkg-Source-Package-V3-native-catch-invalid-version-.patch (text/x-diff, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#700177; Package dpkg-dev. (Sun, 10 Feb 2013 15:39:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Guillem Jover <guillem@debian.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Sun, 10 Feb 2013 15:39:03 GMT) Full text and rfc822 format available.

Message #30 received at 700177@bugs.debian.org (full text, mbox):

From: Guillem Jover <guillem@debian.org>
To: "Bernhard R. Link" <brlink@debian.org>, 700177@bugs.debian.org
Subject: Re: Bug#700177: dpkg-dev: please reject native/non-native version when building native/non-native source packages
Date: Sun, 10 Feb 2013 16:35:29 +0100
On Sat, 2013-02-09 at 15:18:13 +0100, Bernhard R. Link wrote:
> diff --git a/scripts/Dpkg/Source/Package/V3/native.pm b/scripts/Dpkg/Source/Package/V3/native.pm
> index ba6539a..32e3c1b 100644
> --- a/scripts/Dpkg/Source/Package/V3/native.pm
> +++ b/scripts/Dpkg/Source/Package/V3/native.pm
> @@ -64,7 +64,9 @@ sub do_extract {
>  }
>  
>  sub can_build {
> -    return 1;
> +    my ($self, $dir) = @_;
> +    my $v = Dpkg::Version->new($self->{'fields'}->{'Version'});
> +    return (!!$v->is_native(), _g("native package version may not have a revision"));

I've changed this to not return a string when returning true.

And added two missing use Dpkg::Version to the format modules.

Thanks,
Guillem



Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#700177; Package dpkg-dev. (Thu, 18 Apr 2013 13:21:09 GMT) Full text and rfc822 format available.

Acknowledgement sent to Matthias Klose <doko@debian.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Thu, 18 Apr 2013 13:21:09 GMT) Full text and rfc822 format available.

Message #35 received at 700177@bugs.debian.org (full text, mbox):

From: Matthias Klose <doko@debian.org>
To: 700177@bugs.debian.org, "Bernhard R. Link" <brlink@debian.org>
Subject: Re: Bug#700177: dpkg-dev: please reject native/non-native version when building native/non-native source packages
Date: Thu, 18 Apr 2013 15:17:55 +0200
This looks like an arbitrary restriction.  There is no rationale given for that
it is "confusing".

So here's a rationale why the *new* behaviour is "confusing".  For packaging
reasons you often split up packages in separate source packages.  However this
software is still upstream software, and seeing differing versioning schemas for
a package built from python3.3 and python3.3-stdlib-extensions would be
unexpected and confusing.



Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#700177; Package dpkg-dev. (Thu, 18 Apr 2013 13:36:17 GMT) Full text and rfc822 format available.

Acknowledgement sent to Andrey Rahmatullin <wrar@wrar.name>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Thu, 18 Apr 2013 13:36:17 GMT) Full text and rfc822 format available.

Message #40 received at 700177@bugs.debian.org (full text, mbox):

From: Andrey Rahmatullin <wrar@wrar.name>
To: Matthias Klose <doko@debian.org>, 700177@bugs.debian.org
Subject: Re: Bug#700177: dpkg-dev: please reject native/non-native version when building native/non-native source packages
Date: Thu, 18 Apr 2013 19:35:54 +0600
On Thu, Apr 18, 2013 at 03:17:55PM +0200, Matthias Klose wrote:
> This looks like an arbitrary restriction.  There is no rationale given for that
> it is "confusing".
If you read 5.6.12 replacing "piece of software was written specifically
to be a Debian package" with "native package" you will see that native
packages with a dash in the version are forbidden and non-native packages
are assumed to have a debian_revision part. Isn't that enough?

> So here's a rationale why the *new* behaviour is "confusing".  For packaging
> reasons you often split up packages in separate source packages.  However this
> software is still upstream software, and seeing differing versioning schemas for
> a package built from python3.3 and python3.3-stdlib-extensions would be
> unexpected and confusing.
How is this relevant here?

-- 
WBR, wRAR



Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#700177; Package dpkg-dev. (Thu, 18 Apr 2013 17:00:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Bernhard R. Link" <brlink@debian.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Thu, 18 Apr 2013 17:00:04 GMT) Full text and rfc822 format available.

Message #45 received at 700177@bugs.debian.org (full text, mbox):

From: "Bernhard R. Link" <brlink@debian.org>
To: Matthias Klose <doko@debian.org>
Cc: 700177@bugs.debian.org
Subject: Re: Bug#700177: dpkg-dev: please reject native/non-native version when building native/non-native source packages
Date: Thu, 18 Apr 2013 18:56:25 +0200
* Matthias Klose <doko@debian.org> [130418 15:17]:
> So here's a rationale why the *new* behaviour is "confusing".  For packaging
> reasons you often split up packages in separate source packages.  However this
> software is still upstream software, and seeing differing versioning schemas for
> a package built from python3.3 and python3.3-stdlib-extensions would be
> unexpected and confusing.

You seem to be speaking about source package names.
I fail to see how that is related to dashes in versions.

        Bernhard R. Link




Added tag(s) pending. Request was from Guillem Jover <guillem@debian.org> to control@bugs.debian.org. (Sun, 07 Jul 2013 23:21:28 GMT) Full text and rfc822 format available.

Message sent on to "Bernhard R. Link" <brlink@debian.org>:
Bug#700177. (Sun, 07 Jul 2013 23:21:54 GMT) Full text and rfc822 format available.

Message #50 received at 700177-submitter@bugs.debian.org (full text, mbox):

From: Guillem Jover <guillem@debian.org>
To: 700177-submitter@bugs.debian.org
Subject: Bug#700177 marked as pending
Date: Sun, 07 Jul 2013 23:17:05 +0000
tag 700177 pending
thanks

Hello,

Bug #700177 reported by you has been fixed in the Git repository. You can
see the changelog below, and you can check the diff of the fix at:

    http://git.debian.org/?p=dpkg/dpkg.git;a=commitdiff;h=acc1f37

---
commit acc1f37933b2444631eb510f5450985c8f7270c7
Author: Bernhard R. Link <brlink@debian.org>
Date:   Sun Feb 10 16:07:34 2013 +0100

    Dpkg: Catch mismatches between version strings and format versions
    
    Ensure that a 3.0 (quilt) package has a non-native version and that
    a 3.0 (native) package has a native version. To get the information,
    extend Dpkg::Version with a is_native method to check whether a
    version has a revision or not.
    
    [guillem@debian.org:
     - Add is_native to history of changes.
     - Do not return an error string when returning a true result. ]
    
    Closes: #700177
    
    Signed-off-by: Guillem Jover <guillem@debian.org>

diff --git a/debian/changelog b/debian/changelog
index caa2a8c..1f6b0ba 100644
--- a/debian/changelog
+++ b/debian/changelog
@@ -114,6 +114,10 @@ dpkg (1.17.0) UNRELEASED; urgency=low
     Thanks to Colin Watson <cjwatson@ubuntu.com>. Closes: #697297
   * Move epoch-less or revision-less output logic to Dpkg::Version.
     Based on a patch by Bernhard R. Link <brlink@debian.org>.
+  * Catch mismatches between version strings and format versions in
+    dpkg-source. Ensure that a 3.0 (quilt) package has a non-native version
+    and that a 3.0 (native) package has a native version. Closes: #700177
+    Thanks to Bernhard R. Link <brlink@debian.org>.
 
   [ Updated programs translations ]
   * Fix typo in Spanish translation of update-alternatives.



Reply sent to Guillem Jover <guillem@debian.org>:
You have taken responsibility. (Sat, 27 Jul 2013 04:07:14 GMT) Full text and rfc822 format available.

Notification sent to "Bernhard R. Link" <brlink@debian.org>:
Bug acknowledged by developer. (Sat, 27 Jul 2013 04:07:14 GMT) Full text and rfc822 format available.

Message #55 received at 700177-close@bugs.debian.org (full text, mbox):

From: Guillem Jover <guillem@debian.org>
To: 700177-close@bugs.debian.org
Subject: Bug#700177: fixed in dpkg 1.17.0
Date: Sat, 27 Jul 2013 04:03:02 +0000
Source: dpkg
Source-Version: 1.17.0

We believe that the bug you reported is fixed in the latest version of
dpkg, which is due to be installed in the Debian FTP archive.

A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 700177@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Guillem Jover <guillem@debian.org> (supplier of updated dpkg package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@ftp-master.debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Fri, 26 Jul 2013 23:54:54 +0200
Source: dpkg
Binary: libdpkg-dev dpkg dpkg-dev libdpkg-perl dselect
Architecture: source amd64 all
Version: 1.17.0
Distribution: unstable
Urgency: low
Maintainer: Dpkg Developers <debian-dpkg@lists.debian.org>
Changed-By: Guillem Jover <guillem@debian.org>
Description: 
 dpkg       - Debian package management system
 dpkg-dev   - Debian package development tools
 dselect    - Debian package management front-end
 libdpkg-dev - Debian package management static library
 libdpkg-perl - Dpkg perl modules
Closes: 162541 163763 284664 635117 657627 659814 676664 681371 681470 684196 685096 686782 689193 691449 691745 697297 698881 699807 700177 703092 704240 707323 708292 708375 708607 710265 711647 711936 712976 713020 715334 716948
Changes: 
 dpkg (1.17.0) unstable; urgency=low
 .
   [ Guillem Jover ]
   * Switch update-alternatives back to a fatal error on out of range priority
     on --install.
   * Document dpkg-deb --debug in --help output.
   * Bump Standards-Version to 3.9.4 (no changes needed).
   * Use the new canonical dpkg git Vcs URLs.
   * Remove ancient version from zlibg1-dev Build-Depends.
   * Add compression development packages to libdpkg-dev Depends.
   * Man pages cleanup:
     - Disable justification and hyphenation in SEE ALSO sections.
     - Remove unneeded double quotes in .SH headings.
     - Do not use “header” when “format” or “field” is meant.
     - Move dangers of installing via dpkg-deb from BUGS to a NOTES section.
     - Remove BUGS sections containing obvious or misplaced information.
     - Move BUGS sections before EXAMPLES and SEE ALSO sections.
     - Place ENVIRONMENT and FILES sections contiguously.
     - Move EXIT STATUS section before ENVIRONMENT.
     - Rename CAVEATS sections to NOTES.
     - Fold BACKWARD COMPATIBILITY section into other sections.
     - Document since when DEB_*_MULTIARCH variables are supported.
     - Move compiler flags subsection from ENVIRONMENT to NOTES.
     - Unify WARNING and ERROR sections into DIAGNOSTICS.
     - Unify command-line options into a single OPTIONS section.
     - Mark programs, variables, fields and command-line options in bold.
     - Fold dpkg-architecture(1) DEBIAN/RULES section into EXAMPLES.
     - Fix dpkg-architecture(1) debian/rules usage documentation.
     - Move dpkg-buildflags(1) HARDENING into a new FEATURE AREAS subsection.
     - Improve dpkg-buildflags(1) usage documentation.
       Thanks to Matthijs Kooijman <matthijs@stdin.nl>. Closes: #657627
     - Clarify that DPKG_MAINTSCRIPT_PACKAGE is not arch-qualified.
     - Add triggers to the list of binary control information files.
       Thanks to Charles Plessy <plessy@debian.org>.
   * Use colon instead of dot for user:group in dpkg debug output.
   * Remove support for obsolete DM-Upload-Allowed from Dpkg::Vendor::Debian.
   * Fix update-alternatives to use the current alternative link as the first
     best value, to avoid flip-flops of alternatives with equal priority.
     Closes: #699807
   * Fix clang warnings due to change of alignment requirements.
   * Change copyright file to point to GPL-2 instead of GPL.
   * Do not pass -e in shell script shebangs, set it in the body.
   * Add new dpkg-parsechangelog --show-field option to print a field value.
     Closes: #284664
   * Add new dpkg-buildpackage --force-sign option.
   * By default do not sign builds for UNRELEASED uploads on dpkg-buildpackage.
     Closes: #635117
   * Also check Build-Depends-Arch for minimal versions in dpkg-shlibdeps.
     Closes: #681470
   * Document dpkg-buildflags export mode usage in man page. Closes: #691449
     Thanks to Jonathan Nieder <jrnieder@gmail.com>.
   * Rename dpkg-buildflags configure exporter to cmdline, but preserve
     configure as a legacy alias.
   * Mask fortify hardening option from dpkg-buildflags output on noopt.
     New glibc 2.16 and later, issue a warning on this condition.
     Closes: #691745
   * Refer to path instead of file on dpkg-statoverride.
   * Always print a descriptive architecture column, even for empty or missing
     architectures on «dpkg-query --list».
   * Rework SELinux code on unpack to reload the label database if it has
     changed, for example while upgrading the SELinux policy package.
   * Execute maintainer scripts in a new execution context, based on the
     current one and the specific maintainer script filename, and if it's
     not different to the current one, use "dpkg_script_t" as a fallback.
   * Do not unnecessarily create a dpkg update log record on remove or purge.
   * Always reset want status when removing or purging a package; so this
     now resets holds among others. Closes: #163763
   * Always reset want status when installing a package; so this now resets
     holds among others. Closes: #162541
   * Defer cleanup of .dpkg-new and .dpkg-tmp paths on removal to the point
     when we are definitely removing the main path.
   * Activate file triggers on removal more accurately, only when we know
     we are inevitably removing things.
   * Change dir to / before executing maintainer scripts. Closes: #686782
   * Add new dpkg-deb --deb-format option and base --new and --old on it,
     as the latter are not future-proof, and neither can be guaranteed to
     produce a reliable output file format.
   * Drop archtable. It serves no purpose, it's Debian specific, it's
     usually outdated, and everyone should be using dpkg-architecture anyway.
   * Add musl-linux support to ostable and triplettable.
     Requested-by Kevin Bortis <wermut@gmail.com>.
   * Remove update-alternatives, dpkg-divert and dpkg-statoverride
     compatibility symlinks under /usr/sbin/.
   * Remove install-info wrapper.
   * Only ignore older packages if the existing version is informative. This
     allows any program using libdpkg to parse the available file to see again
     packages with versions lesser than 0-0 (like 0~0-0). Closes: #676664
   * Fix Dpkg::Control::Hash set_options() to take a hash as argument instead
     of two scalars.
   * Add a new Dpkg::Vendor get_vendor_dir() function.
   * Print correct path to vendor directory on error message in dpkg-vendor.
   * Do not hardcode the dpkg system configuration directory in perl scripts,
     respect build time setting.
   * Deprecate Dpkg lowercase and exported by default variables, replaced by
     new unified uppercase non-exported by default ones.
   * Do not set -fstack-protector in the default build flags on arm64 (it's
     not yet supported). Thanks to Matthias Klose <doko@ubuntu.com>.
     Closes: #711936
   * Add GCJFLAGS support to dpkg-buildflags. Closes: #708375
   * Clarify that dpkg --set-selections needs an up-to-date available db,
     by documenting it on the dpkg(1) man page, and warning whenever dpkg
     finds unknown packages while setting the selections. Closes: #703092
   * Print nicer error messages in perl scripts using Getopt::Long by trapping
     $SIG{__WARN__} to call usageerr() on option parse errors.
   * Move the exit call out from usage() in dpkg-scansources so that usageerr()
     gives a correct exit code. Thanks to Bernhard R. Link <brlink@debian.org>.
   * Print correct error message on unknown dpkg-name options before --.
   * Require at least one filename on dpkg-name after --.
   * Switch program usage errors to not print entire --help output.
     Closes: #681371
   * Document that «dpkg-parsechangelog -l-» can be used to read from stdin.
   * Support parsing compressed changelog files transparently. Closes: #684196
   * Sort files inside new diffs generated by dpkg-source lexicographically.
     Closes: #689193
   * Add support for a build_arch option in Dpkg::Deps deps_parse().
     Thanks to Colin Watson <cjwatson@ubuntu.com>. Closes: #697297
   * Move epoch-less or revision-less output logic to Dpkg::Version.
     Based on a patch by Bernhard R. Link <brlink@debian.org>.
   * Catch mismatches between version strings and format versions in
     dpkg-source. Ensure that a 3.0 (quilt) package has a non-native version
     and that a 3.0 (native) package has a native version. Closes: #700177
     Thanks to Bernhard R. Link <brlink@debian.org>.
   * Add support for mipsn32(el) and mips64(el) to arch tables.
     Thanks to YunQiang Su <wzssyqa@gmail.com>. Closes: #685096, #707323
   * Document --file and --label parser options in dpkg-parsechangelog(1).
   * Add a new configure --with-dpkg-deb-compressor option to allow selecting
     the default dpkg-deb compressor, mainly for downstreams.
   * Switch dpkg-deb default compressor from gzip to xz. Build dpkg.deb using
     gzip to make debootstrap life easier on non-Debian based systems.
   * Add support for gzip compression strategies to dpkg-deb. The new
     strategies are: filtered, huffman, rle and fixed.
   * Change dpkg and dpkg-deb help output to recommend apt instead of dselect
     as a user-friendly frontend.
   * Remove temporary file on error during «dpkg-divert --rename».
   * Fix value caching in Dpkg::Arch by not shadowing the variables.
   * Fix chmod() arguments order in Dpkg::Source::Quilt. Closes: #710265
     Thanks to Pablo Oliveira <pablo@sifflez.org>.
   * Add new dpkg-shlibdeps -l option to add private shared library directories.
     This should be used instead of abusing LD_LIBRARY_PATH to pass the paths,
     which might be problematic when cross-compiling. Closes: #698881
   * Only apply empy line and comma cleanups when doing substvar replacements
     on fields where those are relevant. Closes: #659814
   * Do not scan control files twice for PGP signature presence.
 .
   [ Raphaël Hertzog ]
   * Fix dpkg-maintscript-helper rm_conffile and mv_conffile to do nothing
     when the conffile is no longer owned by the current (or named) package.
     Thanks to Steve Langasek for the patch. Closes: #716948
   * Improve dpkg-maintscript-helper behaviour in “Multi-Arch: same” packages
     by arch-qualifying package names read from the environment. Also add
     a warning about this potential problem in the manual page.
   * Fix usage of non-existent _() function in multiple places of the Perl
     code. Thanks to Lincoln Myers <lincoln@netapp.com> for the patch.
     Closes: #708607
 .
   [ Updated programs translations ]
   * Fix typo in Spanish translation of update-alternatives.
     Thanks to Javier Fernandez-Sanguino <jfs@debian.org>. Closes: #713020
 .
   [ Updated programs translations ]
   * Vietnamese (Trần Ngọc Quân). Closes: #715334
 .
   [ Added man page translations ]
   * Italian (Beatrice Torracca). Closes: #711647
 .
   [ Updated man page translations ]
   * Fix wrong translation of "fortify" in French dpkg-buildflags(1) man page.
     Thanks to Christian Perrier <bubulle@debian.org>. Closes: #712976
   * Fix typo in dpkg-source(1) man page French translation.
     Thanks to Cédric Boutillier <boutil@debian.org>. Closes: #708292
   * Japanese (TAKAHASHI Motonobu). Closes: #704240
Checksums-Sha1: 
 7d0a5389a4f986c0e5ae9cebc706d240e3780282 1365 dpkg_1.17.0.dsc
 1eefd9ba1ec7d61697faf82586ecf153b928724f 3783600 dpkg_1.17.0.tar.xz
 7b1b6154ebefd8e7175cb2f3f0bfa9625cc60292 729842 libdpkg-dev_1.17.0_amd64.deb
 44b07a9828968b3d40178a995f2f7e83e6b86630 2624194 dpkg_1.17.0_amd64.deb
 24350e9fc261b9d9fbb49b5f9fc823d6e3f416bd 1194456 dselect_1.17.0_amd64.deb
 f7e55eddd462115c403964ea96d1438093951492 1346654 dpkg-dev_1.17.0_all.deb
 44315dc84dfa31cc9a7a4c3d6240f6059f212690 984038 libdpkg-perl_1.17.0_all.deb
Checksums-Sha256: 
 67c73b04b16a2a067b6f58f463161009b9868392734bac3434d08d8248996a0f 1365 dpkg_1.17.0.dsc
 a424cae7e94c98c3f700dc40eea6bc66ab7a14183c7d6efd2992de8261701352 3783600 dpkg_1.17.0.tar.xz
 de410be6e39b77dc5b381572794412b68b9f0c1076c4c9d60b3da089ddb520af 729842 libdpkg-dev_1.17.0_amd64.deb
 d0f218a17592bf51090c9eb7209047a86170d6c8089fc9c8b685149196764bfe 2624194 dpkg_1.17.0_amd64.deb
 4d86af7e10edd35ac8232801f42293bebbf68576319b4e827de4c30ba48db9df 1194456 dselect_1.17.0_amd64.deb
 f81da86ecd9728fb52ad6452b5b121411fba2188a486338d0b51ceeb6e9b8bde 1346654 dpkg-dev_1.17.0_all.deb
 e3f3b0773b0d1cfbc68a73603ffce6f7a3fc71ca22c3e78a5aea6dfac78264aa 984038 libdpkg-perl_1.17.0_all.deb
Files: 
 9fba33b2f2fe8e4af1585bff1e5bf02c 1365 admin required dpkg_1.17.0.dsc
 7a2a1a1b82a44154a7b6791ccbec03cf 3783600 admin required dpkg_1.17.0.tar.xz
 bee0aabc337738db567c23af184ee235 729842 libdevel optional libdpkg-dev_1.17.0_amd64.deb
 6c79ea18925f5c8ec8f1d871250f2866 2624194 admin required dpkg_1.17.0_amd64.deb
 34b0f0ace57e4583f38dd271f9b3bf2f 1194456 admin optional dselect_1.17.0_amd64.deb
 1bbc56aab4c34600de3b1096c3a3a1ab 1346654 utils optional dpkg-dev_1.17.0_all.deb
 76980aced39400a69192a67247ce10fe 984038 perl optional libdpkg-perl_1.17.0_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.12 (GNU/Linux)

iEYEARECAAYFAlHzPBQACgkQuW9ciZ2SjJul9ACfWjrT9o9dyZAn71cwuK/bd1rp
wv8AnAhTjjV1EGX7v3dGkROgyG7Ws47m
=vJ2Z
-----END PGP SIGNATURE-----




Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Fri, 03 Jan 2014 07:30:34 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sun Apr 20 04:12:44 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.